/*
 * Garoon Portal sample program
 * Copyright (c) 2016 Cybozu
 *
 * Licensed under the MIT License
 * https://opensource.org/licenses/mit-license.php
 */

(function($) {
    "use strict";
    //calculate N month age.
    function calcOneM(n) {
        var dt = new Date();
        dt.setDate(dt.getDate() - parseInt(n, 10));
        var year = dt.getFullYear();
        var month = (dt.getMonth() < 10) ? "0" + (dt.getMonth() + 1) : dt.getMonth() + 1;
        var day = dt.getDate();
        return (year + "-" + month + "-" + day);
    }
    //generate randum numbers.
    function generateRandomx(count) {
        var generated = [];
        var generatedCount = generated.length;
        for (var i = 0; i < count; i++) {
            var candidate = Math.floor(Math.random() * count);
            for (var j = 0; j < generatedCount; j++) {
                if (candidate === generated[j]) {
                    candidate = Math.floor(Math.random() * count);
                    j = -1;
                }
            }
            generated[i] = candidate;
            generatedCount++;
        }
        return generated;
    }
    //100 characters or more, the shortening.
    function textTrimer(tx, limit) {
        var afterTxt = "...";
        var textTrim = tx.substr(0, limit);
        if (limit < tx.length) {
            return textTrim + afterTxt;
        }
        return tx;
    }
    var APP_ID = 15;
    var DATE_NUM = 60;
    var nMonthAgo = "\"" + calcOneM(DATE_NUM) + "\"";
    $.ajax({
        type: "GET",
        url: "/k/v1/records.json",
        data: {app: APP_ID, query: "hire_date > " + nMonthAgo},
        cache: false,
        dataType: "json"
    }).done(function(resp) {
        var records = resp.records;
        var fileKeyArray = [];
        var contentsEle;
        var innerDiv;
        var count = 0;
        var randomAray = generateRandomx(records.length);
        var forNum = (records.length < 5) ? records.length : 5;
        if (records.length === 0) {
            $("<div>").html("<B>" + calcOneM(DATE_NUM) + " 以降に入社した方はいません</B>").
            prependTo($(".template-news-contents"));
            $(".template-news-box").append(
                $("<p>", {
                    text: "Not Found"
                })
            );
            return;
        }
        for (var i = 0; i < forNum; i++) {
            contentsEle = $("#contents-" + i);
            contentsEle.append($("<h2></h2>", {
                text: records[randomAray[i]].name.value +
                    "(" + records[randomAray[i]].department.value + ")"
            }));
            innerDiv = $("<div></div>", {
                class: "box-content"
            });
            innerDiv.append($("<img>", {
                id: "capture-" + i,
                width: "120",
                height: "120"
            }));
            innerDiv.append($("<h3></h3>", {
                text: "座右の銘 : " + records[randomAray[i]].motto.value
            }));
            innerDiv.append($("<p></p>", {
                text: textTrimer(records[randomAray[i]].self_introduction.value, 100)
            }));
            innerDiv.append($("<p></p>", {
                class: "btn btn-link"
            }).append($("<a></a>", {
                href: "/k/" + APP_ID + "/show#record=" + records[randomAray[i]].$id.value,
                text: "自己紹介詳細へ"
            })));
            contentsEle.append(innerDiv);
            fileKeyArray.push(records[randomAray[i]].attachment.value[0].fileKey);
        }
        if (forNum < 5) {
            for (var j = forNum; j <= 5; j++) {
                $("#contents-" + j).append(
                    $("<p>", {
                        text: "Not Found"
                    })
                );
            }
        }
        //generate file objects.
        function loopFetchFile(key) {
            return new Promise(function(resolve) {
                var xhr = new XMLHttpRequest();
                xhr.open("GET", "/k/v1/file.json?fileKey=" + key, true);
                xhr.setRequestHeader('X-Requested-With', 'XMLHttpRequest');
                xhr.responseType = "blob";
                xhr.onload = function() {
                    var blob = xhr.response;
                    var url = window.URL || window.webkitURL;
                    var imageObj = url.createObjectURL(blob);
                    $("#capture-" + count).attr("src", imageObj);
                    if (count < fileKeyArray.length - 1) {
                        count++;
                        return loopFetchFile(fileKeyArray[count]);
                    }
                };
                xhr.send();
            });
        }
        loopFetchFile(fileKeyArray[count]);
    }); //end of done
})(jQuery.noConflict(true)); //jquery
